// Simple serial interface
//
// ====================================================================
// ====================================================================
// S E R I A L
// ====================================================================
// ====================================================================

// ********************************************************************
// initialisateion sets Baud rate based on system clock
// NOTE: only enables transmitter that is used for sending information
// to host
// ********************************************************************
void init_serial(unsigned long PsystemClock,unsigned long baud)
{
unsigned int clk;
	// Alternate pin functions
	// TX (RC4) mapped to RC4 (no change)
	// RX (RC5) mapped to RA1
	apfcon0 = 0x80;

	// Initialise baud rate
	txsta = 0b00100100; // TXEN, BRGH=1
	baudcon.BRG16=1;
	baudcon.SCKP=0; //1;
	clk=(PsystemClock/(baud * 4)) - 1;
	spbrgh = (clk >> 8) & 0xff;
	spbrg = clk & 0xff;
	// Receive is off
	rcsta = 0x80; // just enable serial port, reciever is disabled (CREN=0)
}	

// ******************************************************************************
// putc
// ******************************************************************************
void putch (char c)
{
	while (!pir1.TXIF);		// Wait for send buffer to empty
	txreg = c;			// Send character
}
// ******************************************************************************
// puts, returns length of string
// ******************************************************************************
char puts(char *s)
{
char j=0;
	while(*(s+j)) {
		putch(*(s+j));
		j++;
		if(j>255) break;
	}
	return j;
}

// ******************************************************************************
// prints a number and optional comment to a given speification, i.e
// prnum("\nfred=0x%x02",x1);
// ******************************************************************************
void pnum(char *spec, unsigned long num)
{
char b[12];
	if(strlen(spec)>11) {
		puts("\nerror at prnum");
		return;
	}
	sprintf32(b, spec, num);
	puts(b);
}
